import { Logger } from "../logger/Logger";
import { AuthorityMetadataSource } from "../utils/Constants";
import { StaticAuthorityOptions } from "./AuthorityOptions";
import { CloudDiscoveryMetadata } from "./CloudDiscoveryMetadata";
export declare const rawMetdataJSON: {
    endpointMetadata: {
        "https://login.microsoftonline.com/common/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.chinacloudapi.cn/common/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.microsoftonline.us/common/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.microsoftonline.com/consumers/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.chinacloudapi.cn/consumers/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.microsoftonline.us/consumers/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.microsoftonline.com/organizations/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.chinacloudapi.cn/organizations/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
        "https://login.microsoftonline.us/organizations/": {
            token_endpoint: string;
            token_endpoint_auth_methods_supported: string[];
            jwks_uri: string;
            response_modes_supported: string[];
            subject_types_supported: string[];
            id_token_signing_alg_values_supported: string[];
            response_types_supported: string[];
            scopes_supported: string[];
            issuer: string;
            request_uri_parameter_supported: boolean;
            userinfo_endpoint: string;
            authorization_endpoint: string;
            device_authorization_endpoint: string;
            http_logout_supported: boolean;
            frontchannel_logout_supported: boolean;
            end_session_endpoint: string;
            claims_supported: string[];
            kerberos_endpoint: string;
            tenant_region_scope: null;
            cloud_instance_name: string;
            cloud_graph_host_name: string;
            msgraph_host: string;
            rbac_url: string;
        };
    };
    instanceDiscoveryMetadata: {
        tenant_discovery_endpoint: string;
        "api-version": string;
        metadata: {
            preferred_network: string;
            preferred_cache: string;
            aliases: string[];
        }[];
    };
};
export declare const EndpointMetadata: {
    "https://login.microsoftonline.com/common/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.chinacloudapi.cn/common/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.microsoftonline.us/common/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.microsoftonline.com/consumers/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.chinacloudapi.cn/consumers/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.microsoftonline.us/consumers/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.microsoftonline.com/organizations/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.chinacloudapi.cn/organizations/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
    "https://login.microsoftonline.us/organizations/": {
        token_endpoint: string;
        token_endpoint_auth_methods_supported: string[];
        jwks_uri: string;
        response_modes_supported: string[];
        subject_types_supported: string[];
        id_token_signing_alg_values_supported: string[];
        response_types_supported: string[];
        scopes_supported: string[];
        issuer: string;
        request_uri_parameter_supported: boolean;
        userinfo_endpoint: string;
        authorization_endpoint: string;
        device_authorization_endpoint: string;
        http_logout_supported: boolean;
        frontchannel_logout_supported: boolean;
        end_session_endpoint: string;
        claims_supported: string[];
        kerberos_endpoint: string;
        tenant_region_scope: null;
        cloud_instance_name: string;
        cloud_graph_host_name: string;
        msgraph_host: string;
        rbac_url: string;
    };
};
export declare const InstanceDiscoveryMetadata: {
    tenant_discovery_endpoint: string;
    "api-version": string;
    metadata: {
        preferred_network: string;
        preferred_cache: string;
        aliases: string[];
    }[];
};
export declare const InstanceDiscoveryMetadataAliases: Set<String>;
/**
 * Attempts to get an aliases array from the static authority metadata sources based on the canonical authority host
 * @param staticAuthorityOptions
 * @param logger
 * @returns
 */
export declare function getAliasesFromStaticSources(staticAuthorityOptions: StaticAuthorityOptions, logger?: Logger): string[];
/**
 * Returns aliases for from the raw cloud discovery metadata passed in
 * @param authorityHost
 * @param rawCloudDiscoveryMetadata
 * @returns
 */
export declare function getAliasesFromMetadata(authorityHost?: string, cloudDiscoveryMetadata?: CloudDiscoveryMetadata[], source?: AuthorityMetadataSource, logger?: Logger): string[] | null;
/**
 * Get cloud discovery metadata for common authorities
 */
export declare function getCloudDiscoveryMetadataFromHardcodedValues(authorityHost: string): CloudDiscoveryMetadata | null;
/**
 * Searches instance discovery network response for the entry that contains the host in the aliases list
 * @param response
 * @param authority
 */
export declare function getCloudDiscoveryMetadataFromNetworkResponse(response: CloudDiscoveryMetadata[], authorityHost: string): CloudDiscoveryMetadata | null;
//# sourceMappingURL=AuthorityMetadata.d.ts.map